<?php
#
# $Id: get_currency.php,v 1.0.0.1 2008/11/08 08:10:14 max Exp $
#

if ( !defined('XCART_SESSION_START') ) { header("Location: ../"); die("Access denied"); }

define("GET_CURRENCY", 1);

x_session_register("new_currency");

# Define redirect URL
if ((isset($is_https_redirect) && $is_https_redirect == 'Y') || empty($HTTP_REFERER) || strstr($HTTP_REFERER, "error=disabled_cookies") || !func_is_internal_url($HTTP_REFERER)) {
	if (isset($redirect) && !empty($redirect) && func_is_internal_url(($HTTPS ? ("https://" . $xcart_https_host) : ("http://" . $xcart_http_host) . $redirect))) {
		$l_redirect = ($HTTPS ? ("https://" . $xcart_https_host) : ("http://" . $xcart_http_host)) . $redirect;
	} else {
		$l_redirect = $PHP_SELF . "?" . $QUERY_STRING;
	}

} else {
	$l_redirect = $HTTP_REFERER;
}

$l_redirect = func_qs_remove($l_redirect, "sc", $XCART_SESSION_NAME, 'redirect', 'is_https_redirect');

$old_store_currency = $store_currency;

if ($login) unset($store_currency);

if (defined('IS_ROBOT') && $active_modules['IP_Range']) {
	$regex = '/((([^.]+)\.)+)([a-zA-Z]{2,}|[a-zA-Z.]{5,})/';
	preg_match($regex, $xcart_http_host, $matches);
	$ip_country = $matches[4];
	$ip_currency = func_query_first_cell ("SELECT code FROM $sql_tbl[country_currencies] WHERE country_code = '$ip_country' LIMIT 1");
	if (!empty($ip_currency)) {
		$store_currency = $ip_currency;
	} else {
		$store_currency = 'EUR';
	}
}

if (!empty($_GET["sc"])) {
	$new_currency = $_GET["sc"];
	$new_currency = func_query_first_cell ("SELECT code FROM $sql_tbl[currency_rate] WHERE code='$new_currency' AND active='Y' LIMIT 1");
	if (!empty($new_currency))
		$store_currency = $new_currency;
}

if (empty($store_currency) && !empty($login)) {
	$store_currency = func_query_first_cell ("SELECT currency FROM $sql_tbl[customer_currency] WHERE login='$login' LIMIT 1");
}

if (empty($store_currency) && $active_modules['IP_Range']) {
    $ip_addr = $_SERVER['REMOTE_ADDR'];
	$store_currency = func_query_first_cell ("SELECT $sql_tbl[currency_rate].code FROM $sql_tbl[currency_rate] INNER JOIN $sql_tbl[country_currencies] ON $sql_tbl[currency_rate].code = $sql_tbl[country_currencies].code INNER JOIN $sql_tbl[ip_ranges] ON $sql_tbl[country_currencies].country_code = $sql_tbl[ip_ranges].iso2 WHERE $sql_tbl[ip_ranges].start <= INET_ATON('$ip_addr') AND $sql_tbl[ip_ranges].end >= INET_ATON('$ip_addr') AND $sql_tbl[currency_rate].active = 'Y' LIMIT 1");
	if (empty($store_currency))
		$store_currency = $config['Multi_Currency']['default_currency'];
}

if (empty($store_currency)) {
	$store_currency = $config['General']['currency_symbol'];
	$store_currency = func_query_first_cell ("SELECT $sql_tbl[currencies].code FROM $sql_tbl[currency_rate] INNER JOIN $sql_tbl[currencies] ON $sql_tbl[currency_rate].code = $sql_tbl[currencies].code WHERE ($sql_tbl[currencies].code='$store_currency' OR $sql_tbl[currencies].symbol='$store_currency') AND $sql_tbl[currency_rate].active='Y' LIMIT 1");
}

# Check if the currency is active...
$store_currency = func_query_first_cell ("SELECT code FROM $sql_tbl[currency_rate] WHERE code='$store_currency' AND active='Y' LIMIT 1");

#...if not, take any, first active than any other
if (empty($store_currency))
	$store_currency = func_query_first_cell ("SELECT code FROM $sql_tbl[currency_rate] ORDER BY active DESC LIMIT 1");

if ($login)
	db_query ("UPDATE $sql_tbl[customers] SET currency='$store_currency' WHERE login='$login'");

$shop_currency = func_query_first("SELECT * FROM $sql_tbl[currencies] INNER JOIN $sql_tbl[currency_rate] ON $sql_tbl[currencies].code = $sql_tbl[currency_rate].code WHERE $sql_tbl[currency_rate].code='$store_currency' AND $sql_tbl[currency_rate].active='Y' LIMIT 1");

if ($active_modules['IP_Range'])
	db_query ("UPDATE $sql_tbl[stats_country_visitors] SET currency='$store_currency' WHERE ip='$ip_addr'");

#
# Set cookies
#
if ($store_currency != @$HTTP_COOKIE_VARS["store_currency"] && !defined('NOCOOKIE')) {
	setcookie ("store_currency", "", time()-31536000);
	setcookie ("store_currency", $store_currency, time()+31536000); # for one year
	if ($xcart_http_host != $xcart_https_host) {
		#
		# Set cookies for HTTPS host
		#
		setcookie ("store_currency", "", time()-31536000, "/", $xcart_https_host, 1);
		setcookie ("store_currency", $store_currency, time()+31536000, "/", $xcart_https_host, 1); # for one year
	}
}

$all_currencies = func_query("SELECT * FROM $sql_tbl[currencies] INNER JOIN $sql_tbl[currency_rate] ON $sql_tbl[currencies].code = $sql_tbl[currency_rate].code WHERE $sql_tbl[currency_rate].active='Y' ORDER BY $sql_tbl[currency_rate].order_by");

if (
	!empty($_GET["sc"]) &&
	$old_store_currency != $_GET["sc"] && 
	!defined('IS_ROBOT') &&
	(!preg_match('/\.html?($|\?)|\/$/s', $l_redirect) || preg_match("/^(".preg_quote($http_location, "/")."|".preg_quote($https_location, "/").")/", $l_redirect))
) {
	func_header_location($l_redirect);
}

$smarty->assign ("all_currencies", $all_currencies);
$smarty->assign ("shop_currency", $shop_currency);
$smarty->assign ("store_currency", @$store_currency);
?>
